<?php

/**
 * @author jakubkuranda@gmail.com
 * Date: 2018-01-24
 * Time: 15:00
 */

class TMC_v1_0_3_LicenserFieldType extends TMC_v1_0_3_AdminPageFramework_FieldType_text {

    /**
     * Defines the field type slugs used for this field type.
     */
    public $aFieldTypeSlugs = array( 'licenser' );

    /**
     * Defines the default key-values of this field type.
     */
    protected $aDefaultKeys = array(
        'attributes'            =>  array()
    );

    /**
     * Gets modified field HTML.
     * It adds new script at the end of whole string.
     *
     * @param array $fieldArray
     *
     * @return string
     *
     */
    public function getField( $fieldArray ) {

        $fieldArray['after_input'] .= $this->_getLicenserButton();

        $wholeFieldHtml = parent::getField( $fieldArray );

        return $wholeFieldHtml . PHP_EOL . $this->_getLicenserScript();

    }

    /**
     * @return string
     */
    protected function _getLicenserButton() {

        $buttonText     = __( 'Update license', 'TMC-apf' );
        $buttonAttrs    = array(
            'style'     =>  'margin-left: 1em;'
        );

        return get_submit_button( $buttonText, 'secondary', 'submit_tmc_licenser', false, $buttonAttrs );

    }

    /**
     * Gets whole javascript definition.
     *
     * @return string
     */
    protected function _getLicenserScript() {

        $script = "
            jQuery( document ).ready( function( $ ){
                
                $( '' ).TMC_Licenser();
                
            });
        ";

        return "<script>{$script}</script>";

    }

    /**
     * Enqueue scripts.
     *
     * @return array
     */
    public function getEnqueuingScripts() {

        $scripts = array(
            array(
                'src'           =>  __DIR__ . '/Licenser.js',
                'version'       =>  'TMC_v1_0_3',
                'dependancies'  =>  array( 'jquery' )
            )
        );

        return $scripts;

    }

}