<?php
/*
Plugin Name: Revision Manager TMC
Description: Clone your post, page or custom post type to a draft. Draft up revisions of live, published content.
Author: TheMasterCut
Tags: revisions, revisionize, admin, wiki, accept, revision, revisionary, revision control, revision, manager, notify, draft manager, authors reviser, admin, post, revisions, permissions, post permit, submit changes
Version: 2.0.5
Author: TheMasterCut
Author URI: https://themastercut.co
Text Domain: rm_tmc
License: GPL-2.0+
License URI: http://www.gnu.org/licenses/gpl-2.0.txt
Domain Path: /languages/
*/

defined( 'ABSPATH' ) or die( 'Access denied. Scripts are not allowed.' );

//  ----------------------------------------
//  Check requirements
//  ----------------------------------------

require( __DIR__ . '/lib/ShellPress/src/Shared/Utility/RequirementChecker.php' );

$checker = new ShellPress_RequirementChecker();

$checkWP    = $checker->checkWPVersion(     '4.0', __( "Revision manager TMC requires WordPress in version 4.0 or bigger.", 'rm_tmc' ) );
$checkPHP   = $checker->checkPHPVersion(    '5.3', __( "Revision manager TMC requires PHP in version 5.3 or higher.", 'rm_tmc' ) );

if( ! $checkPHP || ! $checkWP ){
    return;     //  Sorry, but server requirements are not fed!
}

//  ----------------------------------------
//  Core class
//  ----------------------------------------

use tmc\revisionmanager\src\App;

//  We don't have autoloading yet!

require( __DIR__ . '/lib/ShellPress/ShellPress.php' );
require( __DIR__ . '/src/App.php' );

$shellPressArgs = array();

App::initShellPress( __FILE__, 'rm_tmc', '2.0.5' );