<?php
namespace tmc\revisionmanager\src\Components;
use WP_Post;
use WP_Query;

/**
 * @author jakubkuranda@gmail.com
 * Date: 08.03.2018
 * Time: 14:14
 */

//  TODO - clean up

class Utilities {

    /**
     * @param int   $postId
     * @param int   $targetId
     * @param array $args
     *
     * @return bool|int
     */
    function copyPost( $postId, $targetId = null, $args = null ){

        $post = get_post( $postId );

        if( ! $post ){
            return false;
        }

        $linkedArgs = array(
            'comment_status'            =>  $post->comment_status,
            'post_author'               =>  get_current_user_id(),
            'post_content'              =>  $post->post_content,
            'post_content_filtered'     =>  $post->post_content_filtered,
            'post_excerpt'              =>  $post->post_excerpt,
            'post_parent'               =>  $post->post_parent,
            'post_password'             =>  $post->post_password,
            'post_status'               =>  'draft',
            'post_title'                =>  $post->post_title,
            'post_type'                 =>  $post->post_type,
            'tags_input'                =>  $post->tag_input,
            'menu_order'                =>  $post->menu_order
        );

        //  Connect arguments
        if( ! empty( $args ) ){
            $linkedArgs = wp_parse_args( $args, $linkedArgs );
        }

        if( empty( $targetId ) ){

            $targetId = wp_insert_post( $linkedArgs );  //  Create new post

        } else if( is_string( get_post_status( $targetId ) ) ){
            $linkedArgs['ID'] = $targetId;
            $targetId          = wp_update_post( $linkedArgs );  //  Update post

        } else {
            return false;
        }

        $this->copyTaxonomies( $postId, $targetId );
        $this->copyMeta( $postId, $targetId );

        return $targetId;

    }

    /**
     * @param int $sourceId
     * @param int $targetId
     *
     * @return void
     */
    function copyTaxonomies( $sourceId, $targetId ){

        $taxonomies = get_post_taxonomies( $sourceId );

        foreach( $taxonomies as $taxonomy ){
            $post_terms = wp_get_object_terms( $sourceId, $taxonomy, array( 'fields' => 'slugs' ) );
            wp_set_object_terms( $targetId, $post_terms, $taxonomy, false );
        }

    }

    /**
     * @param int $sourceId
     * @param int $targetId
     *
     * @return void
     */
    function copyMeta( $sourceId, $targetId ){

        global $wpdb;

        $post_meta_infos = $wpdb->get_results( "SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$sourceId");

        if( count( $post_meta_infos )!=0 ){

            $sql_query = "INSERT INTO $wpdb->postmeta( post_id, meta_key, meta_value )";

            foreach( $post_meta_infos as $meta_info ) {
                $meta_key = $meta_info->meta_key;
                $meta_value = addslashes($meta_info->meta_value);
                $sql_query_sel[]= "SELECT $targetId, '$meta_key', '$meta_value'";
            }

            $sql_query.= implode( " UNION ALL ", $sql_query_sel );
            $wpdb->query( $sql_query );

        }

    }

    /**
     * Replace supported codes in given string with data.
     *
     * @param string $string
     * @param WP_Post $post
     *
     * @return string
     */
    function replaceCodes( $string, $post ) {

        $author = get_userdata( $post->post_author );

        //  Patterns

        $content_pattern = array(
            '%post_url%',
            '%post_title%',
            '%post_admin_url%',
            '%author_name%',
            '%author_mail%',
            '%site_url%'
        );

        //  Replacements

        $content_replace = array(
            get_permalink( $post->ID ),
            $post->post_title,
            get_edit_post_link( $post->ID ),
            $author->display_name,
            $author->user_email,
            get_site_url()
        );

        //  Perform replacement

        return str_replace( $content_pattern, $content_replace, $string );

    }

    /**
     * Returns random post.
     *
     * @return WP_Post|null
     */
    function getRandomPost() {

        $query = new WP_Query(
            array(
                'post_type'         =>  'post',
                'orderby'           =>  'rand',
                'posts_per_page'    =>  '1'
            )
        );

        $posts = $query->get_posts();

        //  Return only first item from array or null if array is empty.

        return ! empty( $posts ) ? $posts[0] : null;

    }

}